﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace HalaviGrocery
{
    public class Store
    {
        private double cheesePrice;
        private double yogurtPrice;
        private Queue<Delivery> cheeseList;
        private Queue<Delivery> yogurtList;
        public Store(double cheesePrice, double yogurtPrice)
        {
            this.cheesePrice = cheesePrice;
            this.yogurtPrice = yogurtPrice;
            this.cheeseList = new Queue<Delivery>();
            this.yogurtList = new Queue<Delivery>();
        }
        public double GetCheesePrice()
        {
            return this.cheesePrice;
        }
        public double GetYogurtPrice()
        {
            return this.yogurtPrice;
        }
        public void SetCheesePrice(double newPrice)
        {
             this.cheesePrice = newPrice;
        }
        public void SetYogurtPrice(double newPrice)
        {
            this.yogurtPrice = newPrice;
        }
        public void AddCheeseDelivery(string date, int amount)
        {
            Delivery d1 = new Delivery(date, amount);
            this.cheeseList.Insert(d1);
        }
        public void AddYogurtDelivery(string date, int amount)
        {
            Delivery d1 = new Delivery(date, amount);
            this.yogurtList.Insert(d1);
        }
        public void CustomerRequest(string name, int amount)
        {   Delivery temp;
            if (name == "yogurt")
            {
                while (amount > 0)
                {
                   temp = this.yogurtList.Head();
                   if (temp.GetAmount() > amount)
                   {
                       temp.SetAmount(temp.GetAmount() - amount);
                       amount = 0;
                   }
                   else
                   {
                       amount = amount - temp.GetAmount();
                       this.yogurtList.Remove();
                   }
                }
            }
            else //רכישת גבינה
            {
                while(amount > 0)
                {
                    temp = this.cheeseList.Head();
                    if (temp.GetAmount() > amount)
                    {
                        temp.SetAmount(temp.GetAmount() - amount);
                        amount = 0;
                    }
                    else
                    {
                        amount = amount - temp.GetAmount();
                        this.cheeseList.Remove();
                    }
                }
            }
        }
        public void RemoveOldProducts(string today)
        { 
            Delivery temp = cheeseList.Head();
            while (temp.GetDate().CompareTo(today) == -1)
            {
                cheeseList.Remove();
                temp = cheeseList.Head();
            }
            temp = yogurtList.Head();
            while (temp.GetDate().CompareTo(today) == -1)
            {
                yogurtList.Remove();
                temp = yogurtList.Head();
            }
        }
        public override string ToString()
        {
            return "cheese list is " + this.cheeseList.ToString()+"\n"+
            "yogurt list is "+this.yogurtList.ToString();
        }
    }
}
